﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace SimpleMonoGame
{
    class Game : Microsoft.Xna.Framework.Game
    {
        private GraphicsDeviceManager graphics;
        private SpriteBatch batch;

        private Texture2D texture;
        private static Random random = new Random();

        // Game Constructor
        public Game() : base()
        {
            // Display Window Setup
            graphics = new GraphicsDeviceManager(this);
            graphics.IsFullScreen = true;
            DisplayMode displayMode = GraphicsAdapter.DefaultAdapter.CurrentDisplayMode;
            graphics.PreferredBackBufferWidth = 1920;
            graphics.PreferredBackBufferHeight = 1080;
            graphics.SynchronizeWithVerticalRetrace = true;
            graphics.PreferMultiSampling = true;
            graphics.HardwareModeSwitch = true;
            IsMouseVisible = true;
        }

        // Load Content
        protected override void LoadContent()
        {
            batch = new SpriteBatch(GraphicsDevice);

            // Set texture to solid white color
            //texture = new Texture2D(GraphicsDevice, 1, 1);
            //texture.SetData(new[] { Color.White });

            // Set texture to image using a file stream
            FileStream setStream = File.Open(@"images/mario_sun.png", FileMode.Open);
            texture = Texture2D.FromStream(GraphicsDevice, setStream);
            setStream.Dispose();
        }

        // Update
        protected override void Update(GameTime gameTime)
        {
            if (Keyboard.GetState().IsKeyDown(Keys.Escape))
            {
                Program.game.Exit();
            }
        }

        // Draw
        protected override void Draw(GameTime gameTime)
        {
            // Background Clear Color
            //GraphicsDevice.Clear(Color.LightBlue);

            // Sprite Batch
            batch.Begin();

            for (int i = 0; i < 20; i++)
            {
                Color color = new Color(new Vector3((float)random.NextDouble() * (1 - 0) + 0, (float)random.NextDouble() * (1 - 0) + 0, (float)random.NextDouble() * (1 - 0) + 0));
                batch.Draw(texture, new Rectangle(random.Next(-64, 1920), random.Next(-64, 1080), random.Next(1, 80), random.Next(1, 80)), color);
            }

            batch.End();
        }

        // Unload
        protected override void UnloadContent()
        {
            batch.Dispose();
        }
    } 
}
